use std::path::PathBuf;

use serde::Serialize;

use crate::error::CustomError;

pub(crate) trait RendererIntegration {
    fn load_templates<I, P>(&mut self, dust_templates: I) -> Result<(), CustomError>
    where
        I: Iterator<Item = P>,
        P: Into<PathBuf>;

    fn render<C>(&self, context: C) -> Result<String, crate::error::CustomError>
    where
        C: Serialize;
}
